Home | History | Annotate | Line # | Download | only in contrib
gcc_update revision 1.1.1.5.4.1
      1 #! /bin/sh
      2 #
      3 # Update a local Subversion, Git or Mercurial tree from the GCC
      4 # repository, with an emphasis on treating generated files correctly, so
      5 # that autoconf, gperf et al are not required for the ``end'' user.
      6 #
      7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 
      8 # 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
      9 # Originally by Gerald Pfeifer <gerald (at] pfeifer.com>, August 1998.
     10 #
     11 # This script is Free Software, and it can be copied, distributed and
     12 # modified as defined in the GNU General Public License.  A copy of
     13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
     14 #
     15 #
     16 # By default all command-line options are passed to `svn update` or `hg/git
     17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
     18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
     19 # are omitted.
     20 #
     21 # If the first parameter reads --patch, the second parameter is considered
     22 # a patch file.
     23 #
     24 # If the first parameter is --touch, no svn operation will be performed,
     25 # only generated files that appear to be out of date in the local tree
     26 # will be touched.
     27 #
     28 # If the first parameter is --list, a list of the generated files and
     29 # their dependencies will be printed; --help prints this message.
     30 #
     31 # If the first parameter is --silent, this script prints nothing other
     32 # than error messages; the second parameter is then interpreted as above.
     33 #
     34 # Examples:
     35 #
     36 # contrib/gcc_update -r 8712
     37 # contrib/gcc_update --patch some-patch
     38 # contrib/gcc_update --touch
     39 # contrib/gcc_update --list
     40 
     41 
     42 # Default options used when updating (none).
     43 UPDATE_OPTIONS=""
     44 
     45 # Set the locale to C to make this script work for users with foreign
     46 # locale like e.g. French UTF-8.
     47 LANG=C
     48 LC_ALL=C
     49 export LANG LC_ALL
     50 
     51 ######## Anything below shouldn't be changed by regular users.
     52 
     53 # Arrange for the value of $0 to be available for functions
     54 self=$0
     55 
     56 # This function prints its arguments to standard output unless
     57 # "silent" is set.
     58 unset silent
     59 chat () {
     60     if [ -z "$silent" ]; then
     61         echo "$@"
     62     fi
     63 }
     64 
     65 # This function prints a list of all generated files, along with their
     66 # dependencies.  Note that only one target is supported per line: the
     67 # colon is stripped from the output.
     68 files_and_dependencies () {
     69     sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
     70 # fixincludes
     71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
     72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
     73 # intl library
     74 intl/plural.c: intl/plural.y
     75 intl/configure: intl/configure.ac intl/aclocal.m4
     76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
     77 # Now, proceed to gcc automatically generated files
     78 gcc/configure: gcc/configure.ac
     79 gcc/cstamp-h.in: gcc/configure.ac
     80 gcc/config.in: gcc/cstamp-h.in
     81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
     82 gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
     83 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
     84 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
     85 gcc/config/arm/arm-cpu.h: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
     86 gcc/config/arm/arm-cpu-data.h: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
     87 gcc/config/arm/arm-cpu-cdata.h: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
     88 gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
     89 gcc/config/avr/t-multilib: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
     90 gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
     91 gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
     92 gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
     93 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
     94 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
     95 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
     96 gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
     97 gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
     98 # And then, language-specific files
     99 gcc/cp/cfns.h: gcc/cp/cfns.gperf
    100 # testsuite
    101 # Without this, _Pragma3.c can have a false negative.
    102 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
    103 # Similarly, without this, you will see:
    104 # direct2s.c:35: warning: current file is older than direct2.c
    105 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
    106 # lto-plugin
    107 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
    108 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
    109 # And libraries, at last
    110 libbanshee/configure: libbanshee/configure.ac
    111 libmudflap/configure: libmudflap/configure.ac
    112 libobjc/configure: libobjc/configure.ac
    113 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
    114 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
    115 zlib/configure: zlib/configure.ac zlib/aclocal.m4
    116 fastjar/aclocal.m4: fastjar/configure.ac
    117 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
    118 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
    119 boehm-gc/aclocal.m4: boehm-gc/configure.ac
    120 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
    121 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
    122 libada/configure: libada/configure.ac
    123 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
    124 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
    125 libffi/configure: libffi/configure.ac libffi/aclocal.m4
    126 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
    127 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
    128 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
    129 libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
    130 libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
    131 libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
    132 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
    133 libcpp/aclocal.m4: libcpp/configure.ac
    134 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
    135 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
    136 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
    137 libgomp/Makefile.am: libgomp/plugin/Makefrag.am
    138 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
    139 libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
    140 libgomp/configure.ac: libgomp/plugin/configfrag.ac
    141 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
    142 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
    143 libhsail-rt/aclocal.m4: libhsail-rt/configure.ac
    144 libhsail-rt/Makefile.in: libhsail-rt/Makefile.am libhsail-rt/aclocal.m4
    145 libhsail-rt/configure: libhsail-rt/configure.ac libhsail-rt/aclocal.m4
    146 libhsail-rt/target-config.h.in: libhsail-rt/configure.ac libhsail-rt/aclocal.m4
    147 libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
    148 libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
    149 libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
    150 libitm/configure: libitm/configure.ac libitm/aclocal.m4
    151 libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
    152 libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
    153 libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
    154 libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
    155 libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
    156 libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
    157 libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
    158 libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
    159 libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
    160 libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
    161 libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
    162 libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
    163 libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
    164 libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
    165 libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
    166 libcilkrts/aclocal.m4: libcilkrts/configure.ac
    167 libcilkrts/Makefile.in: libcilkrts/Makefile.am
    168 libcilkrts/configure: libcilkrts/configure.ac
    169 liboffloadmic/aclocal.m4: liboffloadmic/configure.ac
    170 liboffloadmic/Makefile.in: liboffloadmic/Makefile.am
    171 liboffloadmic/configure: liboffloadmic/configure.ac
    172 liboffloadmic/plugin/aclocal.m4: liboffloadmic/plugin/configure.ac
    173 liboffloadmic/plugin/Makefile.in: liboffloadmic/plugin/Makefile.am
    174 liboffloadmic/plugin/configure: liboffloadmic/plugin/configure.ac
    175 libbacktrace/aclocal.m4: libbacktrace/configure.ac
    176 libbacktrace/Makefile.in: libbacktrace/Makefile.am libbacktrace/aclocal.m4
    177 libbacktrace/configure: libbacktrace/configure.ac libbacktrace/aclocal.m4
    178 libbacktrace/config.h.in: libbacktrace/configure.ac libbacktrace/aclocal.m4
    179 # Top level
    180 Makefile.in: Makefile.tpl Makefile.def
    181 configure: configure.ac config/acx.m4
    182 EOF
    183 }
    184 
    185 
    186 # This function touches generated files such that the ``end'' user does
    187 # not have to rebuild them.
    188 touch_files () {
    189     rm -f Makefile.$$
    190     echo 'all: \' > Makefile.$$
    191     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
    192     echo '; @true' >> Makefile.$$
    193     files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
    194     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
    195     echo ':' >> Makefile.$$
    196     echo '	@for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
    197     echo '	echo Touching $@...; \' >> Makefile.$$
    198     chat '	echo Touching $@... 1>&2; \' >> Makefile.$$
    199     echo '	touch $@' >> Makefile.$$
    200     files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
    201 
    202     # We would have to explicitly shut off the "Entering... Leaving..."
    203     # messages through "--no-print-directory" to handle the case when
    204     # we were called from a recursive invocation (i.e. "$(MAKE)" in a
    205     # Makefile, not just make).  Passing only "-s" doesn't help then,
    206     # because make has helpfully added "-w" to MAKEFLAGS automatically.
    207     # Unfortunately we do not require GNU make other than for building
    208     # and testing, so let's just grep known text explicitly echoed by
    209     # the rule.
    210     while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
    211       sleep 1
    212     done 2>&1
    213     rm -f Makefile.$$
    214 }
    215 
    216 
    217 # Whenever we update the tree or install a patch, we may be modifying
    218 # this script.  By re-execing it, we ensure that the appropriate
    219 # dependencies and rules will be used.
    220 touch_files_reexec () {
    221     chat "Adjusting file timestamps"
    222     exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
    223 }
    224 
    225 # This functions applies a patch to an existing tree.
    226 apply_patch () {
    227     if [ -f "$1" ]; then
    228 	echo "Applying patch file $1"
    229 	case $1 in
    230 	*gz)
    231 	    gzip -d -c "$1" | patch -p1 ;;
    232 	*bz2)
    233 	    bzip2 -d -c "$1" | patch -p1 ;;
    234 	*)
    235 	    patch -p1 < "$1";;
    236 	esac
    237     fi
    238     touch_files_reexec
    239 }
    240 
    241 # Check whether this indeed looks like a local tree.
    242 if [ ! -f gcc/version.c ]; then
    243     echo "This does not seem to be a GCC tree!"
    244     exit
    245 fi
    246 
    247 case "$1" in
    248 --silent)
    249     silent=t
    250     shift
    251     ;;
    252 esac
    253 
    254 case "$1" in
    255 # First of all, check whether we are going to process a patch.
    256 --patch)
    257     if test "$#" != 2; then
    258         echo "$1" expects only one argument >&2
    259 	exit 1
    260     fi
    261     apply_patch "${2}"
    262     exit $?
    263     ;;
    264 
    265 --touch)
    266     if test "$#" != 1; then
    267         echo "$1" does not expect any argument >&2
    268 	exit 1
    269     fi
    270     touch_files
    271     exit $?
    272     ;;
    273 
    274 --list)
    275     if test "$#" != 1; then
    276         echo "$1" does not expect any argument >&2
    277 	exit 1
    278     fi
    279     files_and_dependencies | sed 's/ /: /'
    280     exit $?
    281     ;;
    282 
    283 --help)
    284     sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
    285 \
    286 
    287 p
    288 }' \
    289 	-e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
    290     exit $?
    291     ;;
    292 
    293 esac
    294 
    295 # Check for known version control systems.
    296 if [ -d .git ]; then
    297     GCC_GIT=${GCC_GIT-${GIT-git}}
    298     vcs_type="git"
    299 elif [ -d .hg ]; then
    300     GCC_HG=${GCC_HG-${HG-hg}}
    301     vcs_type="hg"
    302 elif [ -d .svn ]; then
    303     GCC_SVN=${GCC_SVN-${SVN-svn}}
    304     vcs_type="svn"
    305 else
    306     echo "This does not seem to be a GCC GIT/HG/SVN tree!"
    307     exit
    308 fi
    309 
    310 # Check command-line options
    311 if [ x"${1}"x = x"--nostdflags"x ]; then
    312     shift
    313 else
    314     set -- $UPDATE_OPTIONS ${1+"$@"}
    315 fi
    316 
    317 case $vcs_type in
    318     git)
    319 	chat "Updating GIT tree"
    320 
    321 	$GCC_GIT diff --quiet --exit-code HEAD
    322 	if [ $? -ne 0 ]; then
    323             echo "Attempting to update a dirty git tree!" >&2
    324             echo "Commit or stash your changes first and retry." >&2
    325             exit 1
    326 	fi
    327 
    328 	$GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
    329 	if [ $? -ne 0 ]; then
    330             (touch_files_reexec)
    331             echo "git pull of full tree failed." >&2
    332             exit 1
    333 	fi
    334 
    335 	revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
    336 	branch=`$GCC_GIT name-rev --name-only HEAD || :`
    337 	;;    
    338 
    339     hg)
    340 	chat "Updating HG tree"
    341 
    342 	# Add -q so untracked files aren't listed.
    343 	if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
    344             echo "Attempting to update a dirty hg tree!" >&2
    345             echo "Commit or revert your changes first and retry." >&2
    346             exit 1
    347 	fi
    348 
    349 	# Check for mq extension.  mq patches must be popped so tip has
    350 	# been converted from the SVN tree.
    351 	if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
    352 	    # FIXME: Perhaps pop queue instead?  We could do that since we
    353 	    # know the tree is clean.
    354 	    echo "Attempting to update hg tree with mq patches applied!" >&2
    355 	    echo "Pop your patches first and retry." >&2
    356 	    exit 1
    357 	fi
    358 
    359 	# Update tree, but make sure to only pull the default branch.
    360 	# Otherwise all branches in the upstream repo are added, even if
    361 	# only a single one has been cloned.
    362 	$GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
    363 	if [ $? -ne 0 ]; then
    364             (touch_files_reexec)
    365             echo "hg pull of full tree failed." >&2
    366             exit 1
    367 	fi
    368 
    369 	# Update tree.  Needs to be done separately from pull so
    370 	# gcc_update -rREV works.
    371 	$GCC_HG update ${silent+-q} ${1+"$@"}
    372 	if [ $? -ne 0 ]; then
    373             (touch_files_reexec)
    374             echo "hg update of full tree failed." >&2
    375             exit 1
    376 	fi
    377 
    378 	# Extract SVN revision corresponding to parents, as stored by
    379 	# hg convert.  Before hg 1.4.3, there's no template keyword
    380 	# corresponding to the extra: tag, so need to use hg log --debug
    381 	# to extract the info.
    382 	parents=`$GCC_HG parents --template '{rev}'`
    383 	convert_revision=`$GCC_HG log --debug -r$parents | \
    384 	    sed -ne "/^extra:.*convert_revision=svn:/ {
    385 	        s%^[^/]*/%%
    386 		p
    387 	    }"`
    388 	revision=`echo $convert_revision | sed -e 's/.*@//'`
    389 	branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
    390 	;;
    391 
    392     svn)
    393 	chat "Updating SVN tree"
    394 
    395 	$GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
    396 	if [ $? -ne 0 ]; then
    397 	    (touch_files_reexec)
    398 	    echo "SVN update of full tree failed." >&2
    399 	    exit 1
    400 	fi
    401 
    402 	revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
    403 	branch=`$GCC_SVN info | sed -ne "/^URL:/ {
    404 	    s,.*/trunk,trunk,
    405 	    s,.*/branches/,,
    406 	    s,.*/tags/,,
    407 	    p
    408 	}"`
    409 	;;
    410 esac
    411 
    412 rm -f LAST_UPDATED gcc/REVISION
    413 {
    414     date
    415     echo "`TZ=UTC date` (revision $revision)"
    416 } > LAST_UPDATED
    417 echo "[$branch revision $revision]" > gcc/REVISION
    418 
    419 touch_files_reexec
    420